package nl.billinghouse.rme;

import java.io.IOException;
import java.util.Date;
import java.util.List;
import java.util.Set;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonPrimitive;

import log.Log;
import net.indiespot.sql.data.Fetcher;
import net.indiespot.sql.data.JdbcRecordManager;
import net.indiespot.sql.data.JsonRecordManager;
import net.indiespot.sql.data.Key;
import net.indiespot.sql.data.RecordQuery;
import nl.billinghouse.rme.dao.Build;
import nl.billinghouse.rme.dao.Portal;
import nl.billinghouse.rme.utility.JsonIO;
import nl.billinghouse.rme.utility.JsonServlet;
import nl.west.rme.common.Hash;

public class PortalServlet extends JsonServlet {
	@Override
	protected void onBeforeService(HttpServletRequest req, HttpServletResponse resp) {
		super.onBeforeService(req, resp);

		try {
			Thread.sleep(500 + (long) (Math.random() * 500));
		} catch (InterruptedException exc) {

		}
	}

	public JsonElement doGetAll(JsonElement elem, HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {

		List<Portal> portals;
		{
			RecordQuery rq = new RecordQuery();
			rq.withSQL("SELECT Portal.*       ");
			rq.withSQL("  FROM Portal         ");
			rq.withSQL(" ORDER BY id DESC     ");
			portals = rq.queryOrdered(Portal.class);
		}

		return JsonRecordManager.toJsonArray(portals);
	}

	public JsonElement doPostPublish(JsonElement elem, HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {

		Portal portal = JsonRecordManager.fromJson(Portal.class, (JsonObject) elem);
		Build build = portal.build.select();

		BuildService.publish(portal, build);

		return new JsonPrimitive(true);
	}
}
