package nl.billinghouse.rme;

import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Set;

import org.springframework.http.ResponseEntity;
import org.springframework.http.converter.FormHttpMessageConverter;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.web.client.RestTemplate;

import com.google.gson.Gson;
import com.google.gson.JsonObject;
import nl.billinghouse.rme.utility.JsonIO;

public class SuiteCRM {
	private static final String username = "restuser";
	private static final String password_md5 = "3c605d74d479e7063e7efe4af2523413";
	//private static final String rest_url = "http://sugarcrmdev.co.uk/energie/custom/service/v4_1_1/rest.php";
	private static final String rest_url = "http://manui.essent.emadev.nl/suitecrm/custom/service/v4_1_1/rest.php";

	public static String createSessionId() {
		final Map<String, String> user_auth = new HashMap<>();
		user_auth.put("user_name", username);
		user_auth.put("password", password_md5);

		final Map<String, Map<String, String>> rest_data = new HashMap<>();
		rest_data.put("user_auth", user_auth);

		final MultiValueMap<String, String> form = new LinkedMultiValueMap<>();
		form.add("method", "login");
		form.add("input_type", "JSON");
		form.add("response_type", "JSON");
		form.add("application_name", "suitecrm");
		form.add("rest_data", new Gson().toJson(rest_data));

		final RestTemplate restTemplate = new RestTemplate();
		restTemplate.getMessageConverters().add(new FormHttpMessageConverter());
		final ResponseEntity<LoginResponse> result = restTemplate.postForEntity(rest_url, form, LoginResponse.class);
		return result.getBody().getId();
	}

	public static JsonObject getTeamModel(String teamCode) {
		String sessionId = createSessionId();
		final RestTemplate restTemplate = new RestTemplate();
		restTemplate.getMessageConverters().add(new FormHttpMessageConverter());

		final Set<String> modules = new HashSet<>();
		modules.add("Leads");
		final Set<String> types = new HashSet<>();
		types.add("default");
		final Set<String> views = new HashSet<>();
		views.add("create");
		views.add("fields");

		ModuleLayoutRequest request = new ModuleLayoutRequest(//
				sessionId, modules, types, views, Boolean.FALSE, teamCode);

		final ResponseEntity<String> response = restTemplate.postForEntity(rest_url, request.asMultiValueMap(),
				String.class);

		return (JsonObject) JsonIO.fromJson(response.getBody());
	}

	public static class LoginResponse {
		public String id;

		public LoginResponse(String id) {
			this.id = id;
		}

		public String getId() {
			return id;
		}

		public void setId(String id) {
			this.id = id;
		}
	}

	public static class ModuleLayoutRequest {
		private final String sessionId;
		private final Set<String> modules;
		private final Set<String> types;
		private final Set<String> views;
		private final Boolean md5;
		private final String team;

		public ModuleLayoutRequest(String sessionId, Set<String> modules, Set<String> types, Set<String> views,
				Boolean md5, String team) {
			this.sessionId = sessionId;
			this.modules = modules;
			this.types = types;
			this.views = views;
			this.md5 = md5;
			this.team = team;
		}

		public MultiValueMap<String, Object> asMultiValueMap() {
			final MultiValueMap<String, Object> form = new LinkedMultiValueMap<>();
			form.add("method", "get_module_layout");
			form.add("input_type", "JSON");
			form.add("response_type", "JSON");
			form.add("rest_data", getRestData());
			return form;
		}

		public String getRestData() {

			final Map<String, Object> rest_data = new LinkedHashMap<>();
			rest_data.put("session", sessionId);
			rest_data.put("modules", modules);
			rest_data.put("types", types);
			rest_data.put("views", views);
			rest_data.put("md5", md5);
			rest_data.put("team", team);

			return new Gson().toJson(rest_data);
		}
	}

}
