package nl.west.rme.common;

import nl.west.rme.common.util.RegexRules;
import java.io.IOException;
import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;


public abstract class UriRulesFilter implements Filter
{
  private RegexRules uriMatcher;

  @Override
  public void init(FilterConfig config)
      throws ServletException
  {
    uriMatcher = FilterParamUtils.uriRules(config, "uri-rules", null);
  }

  @Override
  public final void doFilter(
      ServletRequest request, ServletResponse response, FilterChain chain)
      throws IOException, ServletException
  {
    if (!uriMatcher.matchesURI((HttpServletRequest) request)) {
      chain.doFilter(request, response);
    }
    else {
      this.doFilterImpl(request, response, chain);
    }
  }

  public abstract void doFilterImpl(
      ServletRequest request, ServletResponse response, FilterChain chain)
      throws IOException, ServletException;

  @Override
  public void destroy()
  {
    // no-op
  }
}
