/*
 * NAME
 *    $HeadURL$
 * DESCRIPTION
 *    [given below in javadoc format]
 * COPYRIGHT
 *    (c) 2015 West Consulting BV
 * VERSION ID
 *    $Id$
 */
package nl.west.rme.common.util;

public final class Pair<A, B>
{
  private final A a;
  private final B b;

  public Pair(A a, B b)
  {
    this.a = a;
    this.b = b;
  }

  @Override
  public int hashCode()
  {
    return a.hashCode() ^ b.hashCode();
  }

  @Override
  @SuppressWarnings("unchecked")
  public boolean equals(Object obj)
  {
    if (obj == null || this.getClass() != obj.getClass())
      return false;
    final Pair<A, B> that = (Pair<A, B>) obj;
    return Compare.equals(this.a, that.a) && //
        Compare.equals(this.b, that.b);
  }
}
