package nl.west.rme.common.util;

import java.security.SecureRandom;
import java.util.Arrays;


public class SysUtils
{
  public static boolean sleep(long millis)
  {
    try {
      Thread.sleep(millis);

      return true;
    }
    catch (final InterruptedException exc) {
      return false;
    }
  }

  public static byte[] join(byte[] a, byte[] b)
  {
    final byte[] join = new byte[a.length + b.length];
    System.arraycopy(a, 0, join, 0, a.length);
    System.arraycopy(b, 0, join, a.length, b.length);
    return join;
  }

  public static byte[][] split(byte[] join, int index)
  {
    final byte[] a = Arrays.copyOf(join, index);
    final byte[] b = Arrays.copyOfRange(join, index, join.length);
    return new byte[][] { a, b };
  }

  public static int indexOf(byte[] data, byte[] find)
  {
    outer:
    for (int io = 0; io < data.length - find.length; io++) {
      for (int k = 0; k < find.length; k++)
        if (data[io + k] != find[k])
          continue outer;
      return io;
    }
    return -1;
  }

  public static byte[] randomBits(int bits)
  {
    final byte[] data = new byte[(bits + 7) / 8];
    new SecureRandom().nextBytes(data);
    return data;
  }
}
